'''
 * CAN Monitortool for USB-Tiny-CAN 0.2.0.2
 *
 *
 * Copyright (C) 2005 Chi Tai Dang, thesis at chi-tai dot info
 *						All rights reserved
 *
 * Description:
 *		prototype code framework to show the communication between usermode and kernelmode software
 *
 * TODO:
 *		Testing
 *
 * History:
 *	 2005/06/11 - 0.2.0.2 - introduced the Flag DBG
 *	 2005/03/23 - 0.1 - first version
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
'''
import gtk
import gtk.glade
import os, time
from threading import Thread
import thread, threading
import gobject
import struct
from Ioctls import *
#from xml.dom.minidom import getDOMImplementation

try:
    from win32file import *
    from win32api import *
    from win32con import *
    from win32event import *
    from pywintypes import *
    from win32security import *
    from win32process import *
except ImportError:
    print "The CCanMon class module requires the Python Win32 extensions."
    raise

class CCanMon:
    def __init__ ( self ):
        self.DBG = 0
        self.guifile = 'canmong.glade'
        self.IntEvent = 0
        self.IntThread = 0
        self.IntThreadStop = 0
        self.IntDevDisconnected = 0
        self.TryReconnect = 0
        self.TryReconnectLock = 1
        # Read
        self.ReadEvent = 0
        self.ReadThread = 0
        self.ReadThreadStop = 0
        self.GtkThread = 0
        
        # read xml glade file
        self.CFrameWnd = gtk.glade.XML ( self.guifile )

        # get widget references
        self.StatusBar = self.CFrameWnd.get_widget ( "StatusBar" )
        self.SBContext = self.StatusBar.get_context_id ( "common context id" )
        self.BnCC = self.CFrameWnd.get_widget ( "BnCreateClose" )
        self.BnCapture = self.CFrameWnd.get_widget ( "BnCapture" )
        self.BnCapture.set_active ( 0 )
        self.Capture = 0
        self.BnScroll = self.CFrameWnd.get_widget ( "BnScroll" )
        self.BnScroll.set_active ( 0 )
        self.Scroll = 0
        self.EnID = self.CFrameWnd.get_widget ( "EnID" )
        self.EnDLC = self.CFrameWnd.get_widget ( "EnDLC" )
        self.Ext = self.CFrameWnd.get_widget ( "Ext" )
        self.EnD0 = self.CFrameWnd.get_widget ( "EnD0" )
        self.EnD1 = self.CFrameWnd.get_widget ( "EnD1" )
        self.EnD2 = self.CFrameWnd.get_widget ( "EnD2" )
        self.EnD3 = self.CFrameWnd.get_widget ( "EnD3" )
        self.EnD4 = self.CFrameWnd.get_widget ( "EnD4" )
        self.EnD5 = self.CFrameWnd.get_widget ( "EnD5" )
        self.EnD6 = self.CFrameWnd.get_widget ( "EnD6" )
        self.EnD7 = self.CFrameWnd.get_widget ( "EnD7" )
        self.EnD7 = self.CFrameWnd.get_widget ( "EnD7" )
        self.EnACCCode = self.CFrameWnd.get_widget ( "EnACCCode" )
        self.EnACCMask = self.CFrameWnd.get_widget ( "EnACCMask" )
        self.CBBaud = self.CFrameWnd.get_widget ( "CBBaud" )
        self.CBBaud.set_active ( 4 )
        self.SBCanStatus = self.CFrameWnd.get_widget ( "SBCanStatus" )
        self.SBCanContext = self.SBCanStatus.get_context_id ( "can context id" )
        self.InfoDlg = self.CFrameWnd.get_widget ( "InfoDialog" )
        self.InfoDlg.hide()
        self.SendDlg = self.CFrameWnd.get_widget ( "SendDlg" )
        self.ScanDlg = self.CFrameWnd.get_widget ( "CanScan" )
        self.BnMSend = self.CFrameWnd.get_widget ( "BnMSend" )
        self.InternalAct = 0
        
        # set the widget order of tab focus
        # , self.BnMSend
        self.FocusList = (self.EnID, self.EnDLC, self.Ext, self.EnD0, self.EnD1, self.EnD2, self.EnD3, self.EnD4, self.EnD5, self.EnD6, self.EnD7)
        #self.CFrameWnd.get_widget ( "CanMonG" ).set_focus_chain(self.FocusList)
        # TreeView MVC Initialization
        self.TV = self.CFrameWnd.get_widget ( "TreeView" )
        # Create a Model for the Data to store
        self.model = gtk.TreeStore (
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING )
        self.TV.set_model ( self.model )
        
        self.Renderer = gtk.CellRendererText()
        column0 = gtk.TreeViewColumn("Time", self.Renderer, text=0)
        self.TV.append_column(column0)
        column1 = gtk.TreeViewColumn("Ext/Std", self.Renderer, text=1)
        self.TV.append_column(column1)
        column2 = gtk.TreeViewColumn("ID", self.Renderer, text=2)
        self.TV.append_column(column2)
        column3 = gtk.TreeViewColumn("Flags", self.Renderer, text=3)
        self.TV.append_column(column3)
        column4 = gtk.TreeViewColumn("DLC", self.Renderer, text=4)
        self.TV.append_column(column4)
        column5 = gtk.TreeViewColumn("DATA (HEX)", self.Renderer, text=5)
        self.TV.append_column(column5)
        column6 = gtk.TreeViewColumn("DATA (ASCII)", self.Renderer, text=6)
        self.TV.append_column(column6)
        
        # can state
        self.CanStarted = 0
        self.EventsActive = 0
        self.Device = 0
        self.hDevice = 0
        
        # Scan window
        self.BnScan = self.CFrameWnd.get_widget ( "BnScan" )
        self.TVS = self.CFrameWnd.get_widget ( "ScanTreeView" )
        self.smodel = gtk.TreeStore (
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING )
        self.TVS.set_model ( self.smodel )
        column0 = gtk.TreeViewColumn("D.Nr", self.Renderer, text=0)
        self.TVS.append_column(column0)
        column1 = gtk.TreeViewColumn("Vendor ID", self.Renderer, text=1)
        self.TVS.append_column(column1)
        column2 = gtk.TreeViewColumn("Product ID", self.Renderer, text=2)
        self.TVS.append_column(column2)
        column3 = gtk.TreeViewColumn("Revision", self.Renderer, text=3)
        self.TVS.append_column(column3)
        column4 = gtk.TreeViewColumn("Product", self.Renderer, text=4)
        self.TVS.append_column(column4)
        column5 = gtk.TreeViewColumn("Manufacturer", self.Renderer, text=5)
        self.TVS.append_column(column5)
        column6 = gtk.TreeViewColumn("Serial No.", self.Renderer, text=6)
        self.TVS.append_column(column6)
        
    def show ( self ):
        self.CFrameWnd.signal_autoconnect (
        {
         "OnExitApp" : self.OnExitApp,
         "OnMenuExit" : self.OnMenuExit,
         "OnBnCreateClose" : self.OnBnCreateClose,
         "OnMenuReset" : self.OnMenuReset,
         "OnDeviceNr" : self.OnDeviceNr,
         "OnBnScroll" : self.OnBnScroll,
         "OnBnCapture" : self.OnBnCapture,
         "OnTreeViewRow" : self.OnTreeViewRow,
         "OnBnScan" : self.OnBnScan,
         "OnScanTreeView" : self.OnScanTreeView,
         "OnCBBaud" : self.OnCBBaud,
         "OnBnACCCode" : self.OnBnACCCode,
         "OnBnACCMask" : self.OnBnACCMask,
         "OnSend" : self.OnSend,
         "OnMSend" : self.OnMSend,
         "OnInfo" : self.OnInfo,
         "OnBnInfo" : self.OnBnInfo,
         "OnMenuSend" : self.OnMenuSend,
         "OnMenuScan" : self.OnMenuScan,
         "OnSendDlgClose" : self.OnSendDlgClose,
         "OnBnClear" : self.OnBnClear,
         "OnScanDlgClose" : self.OnScanDlgClose,
         "OnMSave" : self.OnMSave,
         "OnMFocus" : self.OnMFocus,
         "OnFocusNix" : self.OnFocusNix
         }
        )
        self.CanText ( "CAN stopped" )
        gtk.threads_init()        
        gtk.threads_enter()
        gobject.timeout_add (3000, self.Watchdog)
        gtk.main ()
        gtk.threads_leave()

    def OnFocusNix ( *args ):
        return gtk.TRUE
    
    # close the device on surprise removal and try to reconnect
    def Watchdog ( self ):
        if self.TryReconnect:
            if self.TryReconnectLock:
                self.TryReconnectLock = 0
                self.BnCC.set_active ( 1 )
                if self.BnCC.get_active ():
                    self.BnCapture.set_active ( 1 )
                    if self.BnCapture.get_active ():
                        self.TryReconnect = 0
                self.TryReconnectLock = 1
        else:
            if self.IntDevDisconnected:
                self.IntDevDisconnected = 0
                self.TryReconnect = 1
                self.BnCapture.set_active ( 0 )
                self.BnCC.set_active ( 0 )
        return 1

    def OnMFocus ( self, window, direction ):
        fwidget = window.focus_child.focus_child.focus_child.focus_child.focus_child
        #print "focus..." + str(fwidget) + str(direction)
        if self.FocusList[len(self.FocusList)-1] == fwidget:
            window.set_focus ( self.FocusList[0] )
            self.FocusList[0].grab_focus()
            window.activate_focus()
            return gtk.TRUE
        else:
            for i in range( len(self.FocusList) ):
                if self.FocusList[i] == fwidget:
                    window.set_focus ( self.FocusList[i+1] )
                    self.FocusList[i+1].grab_focus()
                    #window.focus_widget ( self.FocusList[i+1] )
                    #print window.get_focus()
                    window.activate_focus()
                    return True
        return False
    def OnInfo ( self, *args ):
        self.InfoDlg.run()
        return
    def OnBnInfo ( self, *args ):
        self.InfoDlg.hide()
        return

    def OnSendDlgClose ( self, *args ):
        self.SendDlg.hide()
        return gtk.TRUE

    def OnScanDlgClose ( self, *args ):
        self.ScanDlg.hide()
        return gtk.TRUE
    
    def OnMenuSend ( self, *args ):
        self.SendDlg.show()
        return

    def OnMenuScan ( self, *args ):
        self.ScanDlg.show()
        return
    
    # all the things to do before exit this application
    def ExitApp ( self ):
        if self.DBG:
            print "do all the things to quit this application"
        self.CloseDeviceSave ()            
        gtk.main_quit ()
            
    # remove the old statusbar message and add a new one
    def Text ( self, Message ):
        self.StatusBar.pop ( self.SBCanContext )
        self.StatusBar.push ( self.SBCanContext, Message )

    def CanText ( self, Message ):
        self.SBCanStatus.pop ( self.SBContext )
        self.SBCanStatus.push ( self.SBContext, Message )
        
    # Event handler for the frame window       
    def OnExitApp ( self, event, widget_object ):
        self.ExitApp ()
        
    def OnDeviceNr ( self, widget_object ):
        if self.hDevice:
            self.Text ( "Connection exists. Invalid operation requested " )
            widget_object.set_value ( self.Device )
        else:
            self.Device = widget_object.get_value_as_int()
            
    # Event handler for the menus
    def OnMenuExit ( self, *args ):
        self.ExitApp ()

    def OnBnScroll ( self, *args ):
        if self.Scroll == 0:
            self.Scroll = 1
        else:
            self.Scroll = 0
        self.BnScroll.set_active ( self.Scroll )

    def CloseDeviceSave ( self ):
        if self.hDevice != 0:
            if self.DBG:
                print "about to stop everything..."
                print "CAN device is started... about to stop it"
            ret = -1
            try:
                ret = DeviceIoControl (
                            self.hDevice, 
                            IOCTL_STOP, 
                            "", 
                            1, 
                            None)
                if self.DBG:
                    print "CAN device stopped with status " + str(ret)
                    
            except Exception, ex:
                if self.DBG:
                    print "failed to stop CAN device with status " + str(ret)
                    print ex.args
            
            self.CanStarted = 0
            if ( self.ReadEvent != 0 ):
                if self.DBG:
                    print "Stopping Read Thread..."
                self.ReadThreadStop = 1
                SetEvent ( self.ReadEvent )
                CloseHandle ( self.ReadEvent )
                self.ReadEvent = 0
            if ( self.IntEvent != 0 ):
                if self.DBG:
                    print "Stopping Interrupt Thread..."
                self.IntThreadStop = 1
                SetEvent ( self.IntEvent )
                CloseHandle ( self.IntEvent )
                self.IntEvent = 0

            CloseHandle ( self.hDevice )
            self.hDevice = 0
            self.CanText ( "CAN stopped" )
            if self.DBG:
                print "... done"

    
    # Event handler for the widgets
    def OnBnCreateClose ( self, *args ):
        if self.hDevice != 0 and not self.BnCC.get_active ():
            self.CloseDeviceSave ()
            self.Text ( "Connection to \\\\.\\CANUSB" + str(self.Device) + " closed !" )
            self.BnCapture.set_active ( 0 )
            self.BnCC.set_active ( 0 )
            self.InternalAct = 0
            self.EnACCMask.set_editable ( 1 )
            self.EnACCCode.set_editable ( 1 )
        else:
            self.Text ( "trying to create handle to \\\\.\\CANUSB" + str(self.Device) )
            try:                
                self.hDevice = CreateFile(
                    "\\\\.\\CANUSB" + str(self.Device), 
                    GENERIC_READ | GENERIC_WRITE, 
                    FILE_SHARE_READ, 
                    None, 
                    OPEN_EXISTING, 
                    0, 
                    0)                

                # get acc code
                ret = -1
                try:
                    ret = DeviceIoControl (
                                self.hDevice, 
                                IOCTL_GET_ACC_CODE, 
                                "", 
                                4, 
                                None)
                    self.EnACCCode.set_text ( '%02X%02X%02X%02X' % ( ord(ret[3]), ord(ret[2]), ord(ret[1]), ord(ret[0]) ) )
                    
                except Exception, ex:
                    if self.DBG:
                        print ex.args
                    CloseHandle ( self.IntEvent )
                    self.IntEvent = 0
                    CloseHandle ( self.ReadEvent )
                    self.ReadEvent = 0
                    return

                # get acc mask
                ret = -1
                try:
                    ret = DeviceIoControl (
                                self.hDevice, 
                                IOCTL_GET_ACC_MASK, 
                                "", 
                                4, 
                                None)
                    self.EnACCMask.set_text ( '%02X%02X%02X%02X' % ( ord(ret[3]), ord(ret[2]), ord(ret[1]), ord(ret[0]) ) )
                    
                except Exception, ex:
                    if self.DBG:
                        print ex.args
                    CloseHandle ( self.IntEvent )
                    self.IntEvent = 0
                    CloseHandle ( self.ReadEvent )
                    self.ReadEvent = 0
                    return
                
                self.Text ( "Connected to \\\\.\\CANUSB" + str(self.Device) )
                self.CanText ( "CAN connected" )
                self.InternalAct = 1
                if not self.BnCC.get_active ():
                    self.BnCC.set_active ( 1 )
                
            except Exception, ex:
                self.Text ( "failed to create handle to \\\\.\\CANUSB" + str(self.Device) )
                self.CanText ( "CAN stopped" )
                if self.DBG:
                    print ex.args
                self.BnCC.set_active ( 0 )
                return
            
    def OnBnCapture ( self, *args ):
        if self.hDevice != 0:
            if self.BnCapture.get_active:
                # create an event for read, and register it
                try:
                    self.ReadEvent = CreateEvent ( None, 0, 0, None )
                    if self.DBG:
                        print self.ReadEvent
                    hRead = struct.pack("<L", self.ReadEvent.handle )
                    ret = DeviceIoControl (
                                self.hDevice, 
                                IOCTL_SET_READ_EVENT, 
                                hRead,
                                0, 
                                None)
                    self.Text ( "Readevent set" )
                except Exception, ex:
                    if self.DBG:
                        print ex.args
                    self.Text ( "failed to register read event !" )
                    CloseHandle ( self.hDevice )
                    self.hDevice = 0
                    self.BnCC.set_active ( 0 )
                    return
                    
                # create an event for interrupt, and register it
                try:
                    self.IntEvent = CreateEvent ( None, 0, 0, None )
                    hInt = struct.pack("<L", self.IntEvent.handle )
                    ret = DeviceIoControl (
                                self.hDevice, 
                                IOCTL_SET_INTERRUPT_EVENT, 
                                hInt,
                                0, 
                                None)
                    self.Text ( "Interrupt event set" )
                except Exception, ex:
                    if self.DBG:
                        print ex.args
                    self.Text ( "failed to register interrupt event !" )
                    CloseHandle ( self.hDevice )
                    self.hDevice = 0
                    CloseHandle ( self.ReadEvent )
                    self.ReadEvent = 0
                    self.BnCC.set_active ( 0 )
                    return
                
                ret = -1
                try:
                    ret = DeviceIoControl (
                                self.hDevice, 
                                IOCTL_START, 
                                "", 
                                1, 
                                None)
                    self.Text ( "CAN device started with status " + str(ord(ret)) )
                    self.BnCC.set_active ( 1 )
                    self.CanStarted = 1                   

                    self.ReadThreadStop = 0     
                    gtk.threads_enter()                    
                    self.ReadThread = ReadThread(self)
                    self.ReadThread.setDaemon(1)
                    self.ReadThread.start()
                    gtk.threads_leave()

                    self.IntThreadStop = 0
                    gtk.threads_enter()
                    self.IntThread = IntThread(self)
                    self.IntThread.setDaemon(1)
                    self.IntThread.start()                    
                    gtk.threads_leave()

                    self.CanText ( "CAN started" )
                    
                except Exception, ex:
                    self.Text ( "failed to start CAN device with status " + str(ret) )
                    if self.DBG:
                        print ex.args
                    CloseHandle ( self.IntEvent )
                    self.IntEvent = 0
                    CloseHandle ( self.ReadEvent )
                    self.ReadEvent = 0
                    return
                self.EnACCMask.set_editable ( 0 )
                self.EnACCCode.set_editable ( 0 )
            else:
                ret = -1
                try:
                    ret = DeviceIoControl (
                                self.hDevice, 
                                IOCTL_STOP, 
                                "", 
                                1, 
                                None)
                except Exception, ex:
                    if self.DBG:
                        print ex.args
                self.EnACCMask.set_editable ( 1 )
                self.EnACCCode.set_editable ( 1 )
                self.CanStarted = 0
        else:
            #self.BnCapture.set_active ( 0 )
            self.EnACCMask.set_editable ( 1 )
            self.EnACCCode.set_editable ( 1 )
            self.CanStarted = 0
            
    def OnTreeViewRow ( self, *args ):
        model, item = self.TV.get_selection().get_selected()
        self.EnID.set_text ( model.get_value(item, 2) )
        bExt = 0
        if model.get_value(item, 1) == "E":
            bExt = 1
        self.Ext.set_active ( bExt )
        self.EnDLC.set_text ( str(int(model.get_value(item, 4), 16)) )
        data = model.get_value(item, 5).split ( " ")
        
        try:
            self.EnD0.set_text ( data[0] )
            self.EnD1.set_text ( data[1] )
            self.EnD2.set_text ( data[2] )
            self.EnD3.set_text ( data[3] )
            self.EnD4.set_text ( data[4] )
            self.EnD5.set_text ( data[5] )
            self.EnD6.set_text ( data[6] )
            self.EnD7.set_text ( data[7] )
        except Exception, ex:
            pass
        return
    
    def OnMenuReset ( self, *args ):

        if self.hDevice == 0:
            self.Text ( "no connection to CAN device \\\\.\\CANUSB" + str(self.Device) )
        else:
            self.Text ( "... about to reset CAN device" )
            ret = -1
            try:
                ret = DeviceIoControl (
                            self.hDevice, 
                            IOCTL_RESET, 
                            "", 
                            1, 
                            None)
                self.Text ( "CAN device reset with status " + str(ret) )
                self.CanStarted = 0
            except Exception, ex:
                self.Text ( "failed to reset CAN device with status " + str(ret) )
                if self.DBG:
                    print ex.args
    
    def OnCBBaud ( self, *args ):
        if self.hDevice == 0 or self.CanStarted:
            self.CanText ( "You can do this only if CAN Device is stopped" )
            return
        try:
            baud = struct.pack("<L", self.CBBaud.get_active () )
            ret = DeviceIoControl (
                        self.hDevice, 
                        IOCTL_SET_BAUD, 
                        baud,
                        0,
                        None)
        except Exception, ex:
            if self.DBG:
                print ex.args
            self.Text ( "failed to set baud " )
            self.CBBaud.set_active ( 4 )
        return

    def OnBnACCCode ( self, *args ):
        if self.hDevice == 0 or self.CanStarted:
            self.CanText ( "You can do this only if CAN Device is stopped" )
            return
        try:
            acccode = struct.pack ( "<L", int ( self.EnACCCode.get_text(), 16 ) )
            ret = DeviceIoControl (
                        self.hDevice, 
                        IOCTL_SET_ACC_CODE, 
                        acccode,
                        0,
                        None)
            self.Text ( "set acc code succeed " )
        except Exception, ex:
            if self.DBG:
                print ex.args
            self.Text ( "set acc code failed " )
        return

    def OnBnACCMask ( self, *args ):
        if self.hDevice == 0 or self.CanStarted:
            self.CanText ( "You can do this only if CAN Device is stopped" )
            return
        try:
            accmask = struct.pack ( "<L", int ( self.EnACCMask.get_text(), 16 ) )
            ret = DeviceIoControl (
                        self.hDevice, 
                        IOCTL_SET_ACC_MASK, 
                        accmask,
                        0,
                        None)
            self.Text ( "set acc mask succeed " )
        except Exception, ex:
            if self.DBG:
                print ex.args
            self.Text ( "set acc mask failed " )
        return

    def OnBnClear ( self, *args ):
        self.model.clear()
        return
    
    def OnBnScan ( self, *args ):
        if self.BnScan.get_active() == 0:            
            smodel = self.smodel
            smodel.clear()
            maxdev = 16
            nfound = 0
            for ndev in range(maxdev):
                try:
                    hDev = CreateFile(
                        "\\\\.\\CANUSB" + str(ndev), 
                        GENERIC_READ | GENERIC_WRITE, 
                        FILE_SHARE_READ, 
                        None, 
                        OPEN_EXISTING, 
                        0, 
                        0)
                    PID = DeviceIoControl (
                            hDev, 
                            IOCTL_GET_PID, 
                            "", 
                            4, 
                            None)
                    VID = DeviceIoControl (
                            hDev, 
                            IOCTL_GET_VID, 
                            "", 
                            4, 
                            None)
                    REV = DeviceIoControl (
                            hDev, 
                            IOCTL_GET_REVISION, 
                            "", 
                            4, 
                            None)
                    Manufacturer = DeviceIoControl (
                            hDev, 
                            IOCTL_GET_MANUFACTURER, 
                            "", 
                            256, 
                            None)
                    Product = DeviceIoControl (
                            hDev, 
                            IOCTL_GET_PRODUCT, 
                            "", 
                            256, 
                            None)
                    SerialNo = DeviceIoControl (
                            hDev, 
                            IOCTL_GET_SERIALNUMBER, 
                            "", 
                            256, 
                            None)
                    CloseHandle ( hDev )
                    row = smodel.insert_after ( None, None )
                    smodel.set_value ( row, 0, ndev )
                    smodel.set_value ( row, 1, '0x%02X%02X' % ( ord(VID[1]), ord(VID[0])) )
                    smodel.set_value ( row, 2, '0x%02X%02X' % ( ord(PID[1]), ord(PID[0])) )
                    smodel.set_value ( row, 3, '%02X.%02X' % ( ord(REV[1]), ord(REV[0])) )
                    smodel.set_value ( row, 4, Product.replace ('\x00','') )
                    smodel.set_value ( row, 5, Manufacturer.replace ('\x00','') )
                    smodel.set_value ( row, 6, SerialNo.replace ('\x00','') )
                    nfound = nfound + 1
                except Exception, ex:
                    #print ex.args
                    pass
            self.Text ( "found %i CAN devices" % nfound )
        self.BnScan.set_active ( 0 )

    def OnScanTreeView ( self, *args ):
        #smodel, item = self.TVS.get_selection().get_selected()
        #self.Device = int(smodel.get_value(item, 0))
        #self.CFrameWnd.get_widget( "DeviceNr" ).set_value ( self.Device )
        return

    def OnSend ( self, *args ):
        if self.hDevice == 0 or self.CanStarted == 0:
            self.Text ( "CAN Device must be started before doing this!" )
            return
        
        # check the values if valid
        tmp = self.CFrameWnd.get_widget ( "SEnID" ).get_text ()
        SID = 0
        try:
            SID = int ( tmp, 16 )
        except Exception, ex:
            self.Text ( "Invalid ID" )
            return
        
        tmp = self.CFrameWnd.get_widget ( "SEnDLC" ).get_text ()
        DLC = 0
        try:
            DLC = int ( tmp, 16 )
        except Exception, ex:
            self.Text ( "Invalid DLC" )
            return        
        if DLC > 8 or DLC < 0:
            self.Text ( "Invalid DLC" )
            return
        flags = ( 0x0f & DLC ) % 9
        if self.CFrameWnd.get_widget ( "SExt" ).get_active ():
            flags = flags | 0x80
            
        tmp = self.CFrameWnd.get_widget ( "SEnD0" ).get_text ()
        D0 = 0
        try:
            D0 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 0:
                self.Text ( "Invalid Data Byte 0" )
                return  
        
        tmp = self.CFrameWnd.get_widget ( "SEnD1" ).get_text ()
        D1 = 0
        try:
            D1 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 1:                
                self.Text ( "Invalid Data Byte 1" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "SEnD2" ).get_text ()
        D2 = 0
        try:
            D2 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 2:
                self.Text ( "Invalid Data Byte 2" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "SEnD3" ).get_text ()
        D3 = 0
        try:
            D3 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 3:
                self.Text ( "Invalid Data Byte 3" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "SEnD4" ).get_text ()
        D4 = 0
        try:
            D4 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 4:
                self.Text ( "Invalid Data Byte 4" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "SEnD5" ).get_text ()
        D5 = 0
        try:
            D5 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 5:
                self.Text ( "Invalid Data Byte 5" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "SEnD6" ).get_text ()
        D6 = 0
        try:
            D6 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 6:
                self.Text ( "Invalid Data Byte 6" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "SEnD7" ).get_text ()
        D7 = 0
        try:
            D7 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 7:
                self.Text ( "Invalid Data Byte 7" )
                return 
        
        # submit the message
        Buffer = struct.pack ( "<LIBBBBBBBBQ", SID, flags, D0, D1, D2, D3, D4, D5, D6, D7, 0 )
        ret = -1
        try:
            ret = WriteFile (
                    self.hDevice, 
                    Buffer, 
                    None)
            self.Text ( "Message submitted successful" )
        except Exception, ex:
            self.Text ( "Message failed to send" )
            #print ex.args
        return

    # be aware that any changes in the definition above must also be
    # put in the following definition
    def OnMSend ( self, *args ):
        if self.hDevice == 0 or self.CanStarted == 0:
            self.Text ( "CAN Device must be started before doing this!" )
            return
        
        # check the values if valid
        tmp = self.CFrameWnd.get_widget ( "EnID" ).get_text ()
        SID = 0
        try:
            SID = int ( tmp, 16 )
        except Exception, ex:
            self.Text ( "Invalid ID" )
            return
        
        tmp = self.CFrameWnd.get_widget ( "EnDLC" ).get_text ()
        DLC = 0
        try:
            DLC = int ( tmp, 16 )
        except Exception, ex:
            self.Text ( "Invalid DLC" )
            return        
        if DLC > 8 or DLC < 0:
            self.Text ( "Invalid DLC" )
            return
        flags = ( 0x0f & DLC ) % 9
        if self.CFrameWnd.get_widget ( "Ext" ).get_active ():
            flags = flags | 0x80
            
        tmp = self.CFrameWnd.get_widget ( "EnD0" ).get_text ()
        D0 = 0
        try:
            D0 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 0:
                self.Text ( "Invalid Data Byte 0" )
                return  
        
        tmp = self.CFrameWnd.get_widget ( "EnD1" ).get_text ()
        D1 = 0
        try:
            D1 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 1:                
                self.Text ( "Invalid Data Byte 1" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "EnD2" ).get_text ()
        D2 = 0
        try:
            D2 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 2:
                self.Text ( "Invalid Data Byte 2" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "EnD3" ).get_text ()
        D3 = 0
        try:
            D3 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 3:
                self.Text ( "Invalid Data Byte 3" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "EnD4" ).get_text ()
        D4 = 0
        try:
            D4 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 4:
                self.Text ( "Invalid Data Byte 4" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "EnD5" ).get_text ()
        D5 = 0
        try:
            D5 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 5:
                self.Text ( "Invalid Data Byte 5" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "EnD6" ).get_text ()
        D6 = 0
        try:
            D6 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 6:
                self.Text ( "Invalid Data Byte 6" )
                return 
        
        tmp = self.CFrameWnd.get_widget ( "EnD7" ).get_text ()
        D7 = 0
        try:
            D7 = int ( tmp, 16 )
        except Exception, ex:
            if DLC > 7:
                self.Text ( "Invalid Data Byte 7" )
                return 
        
        # submit the message
        Buffer = struct.pack ( "<LIBBBBBBBBQ", SID, flags, D0, D1, D2, D3, D4, D5, D6, D7, 0 )
        ret = -1
        try:
            ret = WriteFile (
                    self.hDevice, 
                    Buffer, 
                    None)
            self.Text ( "Message submitted successful" )
        except Exception, ex:
            self.Text ( "Message failed to send" )
            #print ex.args
        return
            
    def OnMSave ( self, *args ):
        imp = getDOMImplementation()
        #dt = implementation.createDocumentType ( 'CANMSGS', '', '' )
        doc = imp.createDocument ( None, 'CANMSGS', None )
        rootElem = doc.documentElement
        text = doc.createTextNode ( ' new ' )
        rootElem.appendChild ( text )
        if self.DBG:
            print doc.__get_StringIO()
        return
    
# Class ReadThread
class ReadThread(Thread):
    def __init__(self, CFrameWnd):
        self.CFrameWnd = CFrameWnd
        Thread.__init__(self)
        
    def run(self):
        if self.CFrameWnd.DBG:
            print "Read thread started..."
        while 1:
            WaitForSingleObject(self.CFrameWnd.ReadEvent, INFINITE)
            if self.CFrameWnd.ReadThreadStop:
                break
            Buffer = ""
            try:
                Buffer = ReadFile (
                                self.CFrameWnd.hDevice, 
                                2400, 
                                None)

                CanMsgs = Buffer[1]
                mcount = len(CanMsgs) / 24
                for ncount in range(mcount):
                    CanMsg = CanMsgs[ncount*24:ncount*24+24]
                    id = ord(CanMsg[0])
                    id = id | (ord(CanMsg[1]) << 8)
                    id = id | (ord(CanMsg[2]) << 16)
                    id = id | (ord(CanMsg[3]) << 24)
                    flags = ord(CanMsg[4])
                    flags = flags | (ord(CanMsg[5]) << 8)
                    flags = flags | (ord(CanMsg[6]) << 16)
                    flags = flags | (ord(CanMsg[7]) << 24)
                    ltime = ord(CanMsg[16])
                    ltime = ltime | (ord(CanMsg[17]) << 8)
                    ltime = ltime | (ord(CanMsg[18]) << 16)
                    ltime = ltime | (ord(CanMsg[19]) << 24)
                    ltime = ltime | (ord(CanMsg[20]) << 32)
                    ltime = ltime | (ord(CanMsg[21]) << 40)
                    ltime = ltime | (ord(CanMsg[22]) << 48)
                    ltime = ltime | (ord(CanMsg[23]) << 56)
                    msize = flags & 0x0f
                    ext = 'S'
                    if  (flags & 0x80) == 0x80:
                        ext = 'E'
                    msg = CanMsg[8:(8+msize)]
                    hmsg = ""
                    for nmsg in range(msize):
                        hmsg = hmsg + '%02X ' % ( ord(CanMsg[8+nmsg]) )
                    # hmsg = '%02X %02X %02X %02X %02X %02X %02X %02X' % ( ord(CanMsg[8]), ord(CanMsg[9]), ord(CanMsg[10]), ord(CanMsg[11]), ord(CanMsg[12]), ord(CanMsg[13]), ord(CanMsg[14]), ord(CanMsg[15]) )
                    utime = TimeFields(ltime)
                    stime = str(utime.Hour) + ":" + str(utime.Minute) + ":" + str(utime.Second) + "." + str(utime.Millis)
                    row = self.CFrameWnd.model.insert(None, 0)
                    self.CFrameWnd.model.set_value(row,0,stime)
                    self.CFrameWnd.model.set_value(row,1,ext)
                    self.CFrameWnd.model.set_value(row,2,hex(id))
                    self.CFrameWnd.model.set_value(row,3,hex(flags))
                    self.CFrameWnd.model.set_value(row,4,msize)
                    self.CFrameWnd.model.set_value(row,5,hmsg)
                    self.CFrameWnd.model.set_value(row,6,msg)
                    
            except Exception, ex:
                if self.CFrameWnd.DBG:
                    print ex.args
            
            if self.CFrameWnd.Scroll:
                path = self.CFrameWnd.model.get_path(row)
                self.CFrameWnd.TV.scroll_to_cell (path, None, False, 0.0, 0.0)
            time.sleep ( 0.2 )
        if self.CFrameWnd.DBG:
            print "Read thread stopped..."
        return 1
            
class IntThread(Thread):
    def __init__(self, CFrameWnd):
        self.CFrameWnd = CFrameWnd
        Thread.__init__(self)
        
    def run(self):
        if self.CFrameWnd.DBG:
            print "Interrupt thread started..."
        while 1:        
            WaitForSingleObject(self.CFrameWnd.IntEvent, INFINITE)
            if self.CFrameWnd.IntThreadStop:
                break
            IntMsg = ""
            try:
                IntMsg = DeviceIoControl (
                                self.CFrameWnd.hDevice, 
                                IOCTL_GET_INTERRUPT, 
                                "", 
                                12, 
                                None)
            except Exception, ex:
                if self.CFrameWnd.DBG:
                    print ex.args
            CStatus = ord(IntMsg[0])
            #if self.CFrameWnd.DBG:
            #    print IntMsg
            if CStatus == 0xc0 or CStatus == 0xa0:
                if self.CFrameWnd.DBG:
                    print "Device disconnected"
                self.CFrameWnd.IntDevDisconnected = 1
                break
        if self.CFrameWnd.DBG:
            print "Interrupt thread stopped..."
        return 1
            

class TimeFields:
    def __init__(self, large_int):
        self.Year = large_int/315360000000000
        r = large_int%315360000000000
        self.Year = self.Year+1601
        self.Days = r/864000000000
        r = r%864000000000
        self.Hour = r/36000000000
        r = r%36000000000
        self.Minute = r/600000000
        r = r%600000000
        self.Second = r/10000000
        r = r%10000000
        self.Millis = r/10000

        #CSHORT Year;315 360 000 000 000
        #CSHORT Month; 25 920 000 000 000
        #CSHORT Day; 864 000 000 000
        #CSHORT Hour; 36 000 000 000
        #CSHORT Minute;  600 000 000
        #CSHORT Second;   10 000 000
        #CSHORT Milliseconds; 10 000
        #CSHORT Weekday;

CanMon=CCanMon()
CanMon.show()


