/*
 * USB-Tiny-CAN Driver
 *
 *
 * Copyright (C) 2005 Chi Tai Dang, thesis at chi-tai dot info
 *						All rights reserved
 *
 * Description:
 *		IOCTL code definitions
 *
 * TODO:
 *
 * History of changes:
 *	 2005/03/15 - 0.1 - first version
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef IOCTLS_H
#define IOCTLS_H

#ifndef CTL_CODE
	#pragma message("CTL_CODE undefined. Include winioctl.h or wdm.h")
#endif

/* driver related */
#define IOCTL_DRIVER_VERSION CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800, METHOD_BUFFERED, FILE_READ_ACCESS)

/*
#define IOCTL_SET_READ_EVENT_STR CTL_CODE(FILE_DEVICE_UNKNOWN, 0x805, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_SET_INTERRUPT_EVENT_STR CTL_CODE(FILE_DEVICE_UNKNOWN, 0x806, METHOD_BUFFERED, FILE_WRITE_ACCESS)
*/
#define IOCTL_SET_READ_EVENT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x810, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_SET_INTERRUPT_EVENT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x811, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_SET_RX_BUFFER_SIZE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x812, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_SET_IO_MODE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x813, METHOD_BUFFERED, FILE_WRITE_ACCESS)

/* io related */
/* only for testing
#define IOCTL_READ CTL_CODE(FILE_DEVICE_UNKNOWN, 0x820, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_READ_KDPRINT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x821, METHOD_BUFFERED, FILE_ANY_ACCESS)
*/
#define IOCTL_GET_INTERRUPT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x822, METHOD_BUFFERED, FILE_READ_ACCESS)
/* only for testing
#define IOCTL_WRITE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x825, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_WRITE_SIMPLE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x826, METHOD_BUFFERED, FILE_ANY_ACCESS)
*/
#define IOCTL_RESET CTL_CODE(FILE_DEVICE_UNKNOWN, 0x831, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_START CTL_CODE(FILE_DEVICE_UNKNOWN, 0x832, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_STOP CTL_CODE(FILE_DEVICE_UNKNOWN, 0x833, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_GET_AVR_STATUS CTL_CODE(FILE_DEVICE_UNKNOWN, 0x834, METHOD_BUFFERED, FILE_READ_ACCESS)

/* tcan related */
#define IOCTL_GET_MANUFACTURER CTL_CODE(FILE_DEVICE_UNKNOWN, 0x840, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_GET_PRODUCT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x841, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_GET_SERIALNUMBER CTL_CODE(FILE_DEVICE_UNKNOWN, 0x842, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_GET_VID CTL_CODE(FILE_DEVICE_UNKNOWN, 0x843, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_GET_PID CTL_CODE(FILE_DEVICE_UNKNOWN, 0x844, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_GET_REVISION CTL_CODE(FILE_DEVICE_UNKNOWN, 0x845, METHOD_BUFFERED, FILE_READ_ACCESS)

/* tcan control access */
/* only for testing
#define IOCTL_CTRLMSG CTL_CODE(FILE_DEVICE_UNKNOWN, 0x860, METHOD_BUFFERED, FILE_ANY_ACCESS)
*/
#define IOCTL_SET_BAUD CTL_CODE(FILE_DEVICE_UNKNOWN, 0x861, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_SET_ACC_CODE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x862, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_GET_ACC_CODE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x863, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_SET_ACC_MASK CTL_CODE(FILE_DEVICE_UNKNOWN, 0x864, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_GET_ACC_MASK CTL_CODE(FILE_DEVICE_UNKNOWN, 0x865, METHOD_BUFFERED, FILE_READ_ACCESS)

/* tcan internal codes */
#define IOCTL_GET_INTERRUPTCOUNT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x880, METHOD_BUFFERED, FILE_READ_ACCESS)

#define IOCTL_MTNC_STALLQUEUE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x885, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MTNC_RESTARTQUEUE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x886, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MTNC_ABORTPIPE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x887, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MTNC_RESETDEVICE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x888, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MTNC_RESETPIPE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x889, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_MTNC_DECONFIGURE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x890, METHOD_BUFFERED, FILE_READ_ACCESS)
/* only for testing
#define IOCTL_WRITE_400 CTL_CODE(FILE_DEVICE_UNKNOWN, 0x899, METHOD_BUFFERED, FILE_ANY_ACCESS)
*/

#endif
