/*
 * USB-Tiny-CAN Driver
 *
 *
 * Copyright (C) 2005 Chi Tai Dang, thesis at chi-tai dot info
 *						All rights reserved
 *
 * Description:
 *		Windows Management and Instrumentation Routines
 *
 * TODO:
 *		Testing
 *
 * History of changes:
 *	 2005/03/23 - 0.1 - first version
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#include "tcan_usb.h"

#ifdef ALLOC_PRAGMA
#pragma alloc_text( PAGE, Tc_DispatchWmi)
#endif 

/******************************************************************************
 
   Tc_DispatchWmi

 Description:
	Dispatcher routine for Windows Management and Instrumentation IRPs

  @deviceObject - the device object
  @Irp

 returns a ntstatus

******************************************************************************/
NTSTATUS Tc_DispatchWmi
(
 IN PDEVICE_OBJECT	deviceObject,
 IN PIRP			Irp
)
{	
	PDEVICE_EXTENSION devExt;

	KdPrint (( DRVNAME "Tc_DispatchWmi()\n" ));
	PAGED_CODE ();

	devExt
		= (PDEVICE_EXTENSION) deviceObject->DeviceExtension;

	IoSkipCurrentIrpStackLocation ( Irp );
	return IoCallDriver ( devExt->NextDeviceObject, Irp );
}	